Index: src/Fl_Scrollbar.cxx
===================================================================
--- src/Fl_Scrollbar.cxx	(revision 6732)
+++ src/Fl_Scrollbar.cxx	(working copy)
@@ -276,6 +276,183 @@
 }
 
 
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+#define CID_LINE_UP	1
+#define CID_PAGE_UP	2
+#define CID_POS		3
+#define CID_PAGE_DN	4
+#define CID_LINE_DN	5
+
+
+void
+Fl_Scrollbar::msaa_valuator_on_change()
+{
+  Fl_Valuator::msaa_valuator_on_change();
+  msaa_notify(EVENT_OBJECT_STATECHANGE, CID_PAGE_UP);
+  msaa_notify(EVENT_OBJECT_STATECHANGE, CID_PAGE_DN);
+}
+
+
+long
+Fl_Scrollbar::msaa_role(long id)
+{
+  switch (id)
+  {
+    case CID_POS:	return ROLE_SYSTEM_INDICATOR;
+    case CID_LINE_UP:	// Fall through
+    case CID_PAGE_UP:	// Fall through
+    case CID_PAGE_DN:	// Fall through
+    case CID_LINE_DN:	return ROLE_SYSTEM_PUSHBUTTON;
+    default:  		return ROLE_SYSTEM_SCROLLBAR;
+  }
+}
+
+
+bool
+Fl_Scrollbar::msaa_name(long id, BSTR* bstr)
+{
+  const char* l;
+  switch (id)
+  {
+    case 0:		return Fl_Slider::msaa_name(0, bstr);
+    case CID_LINE_UP:	l = horizontal() ? "Column left" : "Line up";  break;
+    case CID_LINE_DN:	l = horizontal() ? "Column right" : "Line down";  break;
+    case CID_PAGE_UP:	// Fall through
+    case CID_POS:	// Fall through
+    case CID_PAGE_DN:	return Fl_Slider::msaa_name(id - 1, bstr);
+    default:		return false;
+  }
+  fl_str_to_bstr(l, -1, bstr);
+  return true;
+}
+
+
+long
+Fl_Scrollbar::msaa_state(long id)
+{
+  // Note: size calculations must match those in draw()
+  int X = x() + Fl::box_dx(box());
+  int Y = y() + Fl::box_dy(box());
+  int W = w() - Fl::box_dw(box());
+  int H = h() - Fl::box_dh(box());
+  bool slider_only =
+    ((horizontal() && (W < 3*H)) || (!horizontal() && (H < 3*W)));
+
+  long s = Fl_Widget::msaa_state(0) & ~STATE_SYSTEM_FOCUSABLE;
+  switch (id)
+  {
+    case CID_LINE_UP:	return s | (slider_only ? STATE_SYSTEM_INVISIBLE : 0);
+    case CID_LINE_DN:	return s | (slider_only ? STATE_SYSTEM_INVISIBLE : 0);
+    case CID_PAGE_UP:	// Fall through
+    case CID_POS:	// Fall through
+    case CID_PAGE_DN:	return Fl_Slider::msaa_state(id - 1);
+    default:		return s;
+  }
+}
+
+
+bool
+Fl_Scrollbar::msaa_action(long id, BSTR* bstr)
+{
+  const char* l;
+  switch (id)
+  {
+    case CID_LINE_UP:	// Fall through
+    case CID_PAGE_UP:	// Fall through
+    case CID_PAGE_DN:	// Fall through
+    case CID_LINE_DN:	l = "Press";  break;
+    default:		return false;
+  }
+  fl_str_to_bstr(l, -1, bstr);
+  return true;
+}
+
+
+bool
+Fl_Scrollbar::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id == 0)  return Fl_Widget::msaa_location(0, X, Y, W, H);
+  if (!msaa_visible())  return false;
+
+  // Note: size calculations must match those in draw()
+  long ox, oy, ow, oh;
+  long sxx, syy, sww, shh;
+  Fl_Widget::msaa_location(0, &ox, &oy, &ow, &oh);
+  sxx = (ox += Fl::box_dx(box()));
+  syy = (oy += Fl::box_dy(box()));
+  sww = (ow -= Fl::box_dw(box()));
+  shh = (oh -= Fl::box_dh(box()));
+  bool slider_only =
+    ((horizontal() && (sww < 3*shh)) || (!horizontal() && (shh < 3*sww)));
+  if (!slider_only)
+  {
+    if (horizontal())
+    {
+      sxx += shh; 
+      sww -= 2 * shh;
+    }
+    else
+    {
+      syy += sww;
+      shh -= 2 * sww;
+    }
+  }
+
+  switch (id)
+  {
+    case CID_LINE_UP:
+      if (slider_only)  return false;
+      *X = ox;
+      *Y = oy;
+      *W = *H = (horizontal() ? oh : ow);
+      return true;
+    case CID_LINE_DN:
+      if (slider_only)  return false;
+      *X = ox + (horizontal() ? (ow - oh) : 0);
+      *Y = oy + (horizontal() ? 0 : (oh - ow));
+      *W = *H = (horizontal() ? oh : ow);
+      return true;
+    case CID_PAGE_UP:	// Fall through
+    case CID_POS:	// Fall through
+    case CID_PAGE_DN:
+      return Fl_Slider::msaa_slider_location(id - 1,
+	sxx, syy, sww, shh, X, Y, W, H);
+    default:
+      return false;
+  }
+}
+
+
+bool
+Fl_Scrollbar::msaa_do_action(long id)
+{
+  if (slider_size() >= 1.0)  return false;
+
+  // Calculate new position
+  int ls = maximum()>=minimum() ? linesize_ : -linesize_;
+  int ps = int((maximum()-minimum())*slider_size()/(1.0-slider_size()));
+  int i;
+  switch (id)
+  {
+    case CID_LINE_UP:	i = -ls;  break;
+    case CID_PAGE_UP:	i = -ps + ls;  if (i > -ls)  i = -ls;  break;
+    case CID_PAGE_DN:	i = ps - ls;  if (i < ls)  i = ls;  break;
+    case CID_LINE_DN:	i = ls;  break;
+    default:		return false;
+  }
+  handle_push();
+  handle_drag(clamp(value() + i));
+  handle_release();
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Menu_Button.cxx
===================================================================
--- src/Fl_Menu_Button.cxx	(revision 6732)
+++ src/Fl_Menu_Button.cxx	(working copy)
@@ -117,6 +117,31 @@
   down_box(FL_NO_BOX);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Menu_Button::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_BUTTONDROPDOWN;
+}
+
+
+bool
+Fl_Menu_Button::msaa_menu_location(int pos, long id,
+  long* X, long* Y, long* W, long* H)
+{
+  // Popup menu and child items do not have on-screen location
+  if ((type() != 0) || (pos != 0) || (id != 0))  return false;
+  return Fl_Widget::msaa_location(0, X, Y, W, H);
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Menu.cxx
===================================================================
--- src/Fl_Menu.cxx	(revision 6732)
+++ src/Fl_Menu.cxx	(working copy)
@@ -90,6 +90,16 @@
 public:
   const Fl_Menu_Item* menu;
   menutitle(int X, int Y, int W, int H, const Fl_Menu_Item*);
+
+#ifdef FL_HAVE_MSAA
+protected:
+  // MSAA support
+  bool msaa_name(long id, BSTR* bstr);
+  bool msaa_shortcut(long id, BSTR* bstr);
+
+public:
+  bool on_menubar_;
+#endif // FL_HAVE_MSAA
 };
 
 // each vertical menu has one of these:
@@ -117,6 +127,20 @@
   void autoscroll(int);
   void position(int x, int y);
   int is_inside(int x, int y);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_child_count();
+  bool msaa_name(long id, BSTR* bstr);
+  bool msaa_value(long id, BSTR* bstr);
+  bool msaa_shortcut(long id, BSTR* bstr);
+  bool msaa_put_value(long id, const char* str);
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+
+public:
+  static void msaa_menuwindow_on_select();
+#endif // FL_HAVE_MSAA
 };
 
 #define LEADING 4 // extra vertical leading
@@ -372,6 +396,9 @@
       int ht = Htitle+2*BW+3;
       title = new menutitle(X, Y-ht-dy, Wtitle, ht, t);
     }
+#ifdef FL_HAVE_MSAA
+    title->on_menubar_ = menubar_title;
+#endif // FL_HAVE_MSAA
   } else
     title = 0;
 }
@@ -555,16 +582,28 @@
 }
 
 static inline void setitem(const Fl_Menu_Item* i, int m, int n) {
+#ifdef FL_HAVE_MSAA
+  bool changed = (p->menu_number != m) || (p->item_number != n);
+#endif // FL_HAVE_MSAA
   p->current_item = i;
   p->menu_number = m;
   p->item_number = n;
+#ifdef FL_HAVE_MSAA
+  if (changed)  menuwindow::msaa_menuwindow_on_select();
+#endif // FL_HAVE_MSAA
 }
 
 static void setitem(int m, int n) {
+#ifdef FL_HAVE_MSAA
+  bool changed = (p->menu_number != m) || (p->item_number != n);
+#endif // FL_HAVE_MSAA
   menustate &pp = *p;
   pp.current_item = (n >= 0) ? pp.p[m]->menu->next(n) : 0;
   pp.menu_number = m;
   pp.item_number = n;
+#ifdef FL_HAVE_MSAA
+  if (changed)  menuwindow::msaa_menuwindow_on_select();
+#endif // FL_HAVE_MSAA
 }
 
 static int forward(int menu) { // go to next item in menu menu if possible
@@ -794,6 +833,10 @@
 
   // preselected item, pop up submenus if necessary:
   if (initial_item && mw.selected >= 0) {
+#ifdef FL_HAVE_MSAA
+    if (mw.title) mw.title->show();
+    mw.show();
+#endif // FL_HAVE_MSAA
     setitem(0, mw.selected);
     goto STARTUP;
   }
@@ -989,6 +1032,198 @@
   return ret;
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+bool
+Fl_Menu_Item::msaa_name(BSTR* bstr) const
+{
+  // Copy human-readable label and shortcut
+  const char* l = fl_label_string(labeltype_, text);
+  size_t len;
+  char* name = fl_label_to_text(l, &len);
+  if (!shortcut())  fl_str_to_bstr(name, len, bstr);
+  else
+  {
+    const char* str = fl_shortcut_label(shortcut());
+    size_t full_len = len + strlen(str) + 1;
+    char* s = (char*)malloc(full_len + 1);
+    sprintf(s, "%s\t%s", name, str);
+    fl_str_to_bstr(s, full_len, bstr);
+    free(s);
+  }
+  fl_free_str(name);
+  return true;
+}
+
+
+bool
+Fl_Menu_Item::msaa_value(BSTR* bstr) const
+{
+  // Return value only for button type item
+  if (!checkbox() && !radio())  return false;
+  fl_str_to_bstr((value() ? "1" : "0"), -1, bstr);
+  return true;
+}
+
+
+bool
+Fl_Menu_Item::msaa_shortcut(bool on_menubar, BSTR* bstr) const
+{
+  const char* l = fl_label_string(labeltype_, text);
+  size_t len;
+  char* str = fl_label_to_shortcut(l, &len);
+  if (len && on_menubar)
+  {
+    const char* prefix = "Alt + ";
+    len += strlen(prefix);
+    char* shortcut = (char*)malloc(len + 1);
+    sprintf(shortcut, "%s%s", prefix, str);
+    fl_str_to_bstr(shortcut, len, bstr);
+    free(shortcut);
+  }
+  else if (len)
+  {
+    fl_str_to_bstr(str, len, bstr);
+  }
+  fl_free_str(str);
+  return len > 0;
+}
+
+
+bool
+Fl_Menu_Item::msaa_put_value(const char* str)
+{
+  if (!checkbox() && !radio())  return false;
+  int v = atoi(str);
+  if (radio() && v)  setonly();
+  else if (v)  set();
+  else  clear();
+  return true;
+}
+
+
+bool
+menutitle::msaa_name(long id, BSTR* bstr)
+{
+  if (id != 0)  return false;
+  return menu->msaa_name(bstr);
+}
+
+
+bool
+menutitle::msaa_shortcut(long id, BSTR* bstr)
+{
+  if (id != 0)  return false;
+  return menu->msaa_shortcut(on_menubar_, bstr);
+}
+
+
+void
+menuwindow::msaa_menuwindow_on_select()
+{
+  int m = p->menu_number;
+  if (m < 0)  return;
+
+  int id = p->item_number + 1;
+  if ((m == 0) && p->menubar)
+  {
+    // Set focus to menubar item when it is selected
+    ((Fl_Menu_*)button)->msaa_notify(EVENT_OBJECT_FOCUS, id);
+  }
+  else
+  {
+    // Otherwise set focus to menu item
+    p->p[m]->msaa_notify(EVENT_OBJECT_FOCUS, id);
+  }
+}
+
+
+long
+menuwindow::msaa_child_count()
+{
+  long count = 0;
+  for (const Fl_Menu_Item* m = menu->first();  m->text;
+      m = m->next(),  ++count);
+  return count;
+}
+
+
+bool
+menuwindow::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  bool ok = Fl_Window::msaa_location(0, X, Y, W, H);
+  if ((id == 0) || !ok)  return ok;
+
+  if (!itemheight)
+  {
+    // Handle menubar
+    // NOTE: This must match algorithm in Fl_Menu_::draw()
+    *X += 6;
+    const Fl_Menu_Item* m = menu->first();
+    for (*X += 6;  --id;  m = m->next())
+      *X += m->measure(0, button) + 16;
+    *W = m->measure(0, button) + 6;
+  }
+  else
+  {
+    // Handle popup menu
+    // NOTE: This must match algorithm in menuitem::drawentry()
+    int BW = Fl::box_dx(box());
+    *X += BW;
+    *Y += BW + 1 + (id - 1) * itemheight;
+    *W  = w() - 2 * BW - 1;
+    *H  = itemheight - LEADING;
+  }
+  return true;
+}
+
+
+bool
+menuwindow::msaa_name(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Window::msaa_name(0, bstr);
+  const Fl_Menu_Item* m = menu->first();
+  while (--id)  m = m->next();
+  return m->msaa_name(bstr);
+}
+
+
+bool
+menuwindow::msaa_value(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Window::msaa_value(0, bstr);
+  const Fl_Menu_Item* m = menu->first();
+  while (--id)  m = m->next();
+  return m->msaa_value(bstr);
+}
+
+
+bool
+menuwindow::msaa_shortcut(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Window::msaa_shortcut(0, bstr);
+  const Fl_Menu_Item* m = menu->first();
+  while (--id)  m = m->next();
+  return m->msaa_shortcut(false, bstr);
+}
+
+
+bool
+menuwindow::msaa_put_value(long id, const char* str)
+{
+  if (id == 0)  return Fl_Window::msaa_put_value(0, str);
+  const Fl_Menu_Item* m = menu->first();
+  while (--id)  m = m->next();
+  return ((Fl_Menu_Item*)m)->msaa_put_value(str);
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Text_Display.cxx
===================================================================
--- src/Fl_Text_Display.cxx	(revision 6732)
+++ src/Fl_Text_Display.cxx	(working copy)
@@ -3188,6 +3188,15 @@
     fl_pop_clip();
   }
   fl_pop_clip();
+
+#ifdef FL_HAVE_MSAA
+  int caret_x, caret_y;
+  if (position_to_xy(mCursorPos, &caret_x, &caret_y))
+  {
+    int caret_w = 4;
+    msaa_show_caret(caret_x - caret_w / 2, caret_y, caret_w, mMaxsize);
+  }
+#endif // FL_HAVE_MSAA
 }
 
 // this processes drag events due to mouse for Fl_Text_Display and
@@ -3279,6 +3288,9 @@
     case FL_HIDE:
       if (active_r() && window()) {
         window()->cursor(FL_CURSOR_DEFAULT);
+#ifdef FL_HAVE_MSAA
+        msaa_hide_caret();
+#endif
 
 	return 1;
       } else {
@@ -3404,6 +3416,9 @@
       else return mHScrollBar->handle(event);
 
     case FL_UNFOCUS:
+#ifdef FL_HAVE_MSAA
+      msaa_hide_caret();
+#endif
       if (active_r() && window()) window()->cursor(FL_CURSOR_DEFAULT);
     case FL_FOCUS:
       if (buffer()->selected()) {
Index: src/Fl_Slider.cxx
===================================================================
--- src/Fl_Slider.cxx	(revision 6732)
+++ src/Fl_Slider.cxx	(working copy)
@@ -350,6 +350,242 @@
 		h()-Fl::box_dh(box()));
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+#define CID_PAGE_UP	1
+#define CID_POS		2
+#define CID_PAGE_DN	3
+
+
+void
+Fl_Slider::msaa_valuator_on_change()
+{
+  Fl_Valuator::msaa_valuator_on_change();
+  msaa_notify(EVENT_OBJECT_STATECHANGE, CID_PAGE_UP);
+  msaa_notify(EVENT_OBJECT_STATECHANGE, CID_PAGE_DN);
+}
+
+
+bool
+Fl_Slider::msaa_slider_location(long id,
+  long oX, long oY, long oW, long oH, long* X, long* Y, long* W, long* H)
+{
+  // Note: size calculations must match those in draw()
+  int full_len = horizontal() ? oW : oH;
+  int pos_len = full_len;
+  int up_len = 0;
+  int dn_len = 0;
+
+  // Find position indicator length if it doesn't fill the whole slider
+  if ((slider_size_ >= 0.0) || (slider_size_ <= 1.0))
+  {
+    double v;
+    if (minimum() == maximum())  v = 0.5;
+    else
+    {
+      v = (value() - minimum()) / (maximum() - minimum());
+      if (v > 1.0)  v = 1.0;
+      else if (v < 0.0)  v = 0.0;
+    }
+
+    // Calculate length of position indicator
+    if ((type() == FL_HOR_FILL_SLIDER) || (type() == FL_VERT_FILL_SLIDER))
+      pos_len = 0;
+    else
+    {
+      int min_len = (horizontal() ? oH : oW) / 2 + 1;
+      if ((type() == FL_HOR_NICE_SLIDER) || (type() == FL_VERT_NICE_SLIDER))
+	min_len += 4;
+      pos_len = (int)(slider_size_ * full_len + 0.5);
+      if (pos_len < min_len)  pos_len = min_len;
+    }
+
+    // Calculate length before and after position indicator
+    up_len = (int)(v * (full_len - pos_len) + 0.5);
+    dn_len = full_len - up_len - pos_len;
+  }
+
+  switch (id)
+  {
+    case CID_PAGE_UP:
+      if (up_len == 0)  return false;
+      if (horizontal())
+      {
+        *X = oX;
+        *Y = oY;
+        *W = up_len;
+        *H = oH;
+      }
+      else
+      {
+        *X = oX;
+        *Y = oY;
+        *W = oW;
+        *H = up_len;
+      }
+      return true;
+
+    case CID_POS:
+      if (pos_len == 0)  return false;
+      if (horizontal())
+      {
+        *X = oX + up_len;
+        *Y = oY;
+        *W = pos_len;
+        *H = oH;
+      }
+      else
+      {
+        *X = oX;
+        *Y = oY + up_len;
+        *W = oW;
+        *H = pos_len;
+      }
+      return true;
+
+    case CID_PAGE_DN:
+      if (dn_len == 0)  return false;
+      if (horizontal())
+      {
+        *X = oX + up_len + pos_len;
+        *Y = oY;
+        *W = dn_len;
+        *H = oH;
+      }
+      else
+      {
+        *X = oX;
+        *Y = oY + up_len + pos_len;
+        *W = oW;
+        *H = dn_len;
+      }
+      return true;
+
+    default:
+      return false;
+  }
+}
+
+
+bool
+Fl_Slider::msaa_name(long id, BSTR* bstr)
+{
+  const char* l;
+  switch (id)
+  {
+    case 0:
+	l = label();
+	if (!l || !l[0])  l = horizontal() ? "Horizontal" : "Vertical";
+	break;
+    case CID_PAGE_UP:
+    	l = horizontal() ? "Page left" : "Page up";
+	break;
+    case CID_POS:
+    	l = "Position";
+	break;
+    case CID_PAGE_DN:
+    	l = horizontal() ? "Page right" : "Page down";
+	break;
+    default:
+    	return false;
+  }
+  fl_str_to_bstr(l, -1, bstr);
+  return true;
+}
+
+
+long
+Fl_Slider::msaa_role(long id)
+{
+  switch (id)
+  {
+    case CID_POS:	return ROLE_SYSTEM_INDICATOR;
+    case CID_PAGE_UP:	// Fall through
+    case CID_PAGE_DN:	return ROLE_SYSTEM_PUSHBUTTON;
+    default:  		return ROLE_SYSTEM_SLIDER;
+  }
+}
+
+
+long
+Fl_Slider::msaa_state(long id)
+{
+  long s = Fl_Widget::msaa_state(0) & ~STATE_SYSTEM_FOCUSABLE;
+  switch (id)
+  {
+    case 0:
+      return s | STATE_SYSTEM_FOCUSABLE;
+    case CID_PAGE_UP:
+      return s | (value() <= minimum() ? STATE_SYSTEM_INVISIBLE : 0);
+    case CID_POS:
+      return s | (((type() == FL_HOR_FILL_SLIDER) ||
+      	(type() == FL_VERT_FILL_SLIDER)) ? STATE_SYSTEM_INVISIBLE : 0);
+    case CID_PAGE_DN:
+      return s | (value() >= maximum() ? STATE_SYSTEM_INVISIBLE : 0);
+    default:
+      return s;
+  }
+}
+
+
+bool
+Fl_Slider::msaa_action(long id, BSTR* bstr)
+{
+  const char* l;
+  switch (id)
+  {
+    case CID_PAGE_UP:	// Fall through
+    case CID_PAGE_DN:	l = "Press";  break;
+    default:		return false;
+  }
+  fl_str_to_bstr(l, -1, bstr);
+  return true;
+}
+
+
+bool
+Fl_Slider::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id == 0)  return Fl_Widget::msaa_location(0, X, Y, W, H);
+  if (!msaa_visible())  return false;
+
+  // Note: size calculations must match those in draw()
+  long sxx, syy, sww, shh;
+  Fl_Widget::msaa_location(0, &sxx, &syy, &sww, &shh);
+  return msaa_slider_location(id,
+    sxx + Fl::box_dx(box()), syy + Fl::box_dy(box()),
+    sww - Fl::box_dw(box()), shh - Fl::box_dh(box()), X, Y, W, H);
+}
+
+
+bool
+Fl_Slider::msaa_do_action(long id)
+{
+  // Move slider
+  switch (id)
+  {
+    case CID_PAGE_UP:
+      handle_push();
+      handle_drag(clamp(increment(value(),-1)));
+      handle_release();
+      return true;
+    case CID_PAGE_DN:
+      handle_push();
+      handle_drag(clamp(increment(value(),1)));
+      handle_release();
+      return true;
+    default:
+      return false;
+  }
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
